#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>

long count = 0;

void bubblesort(int a[], int n)
{
  bool done = false;
  while(!done)
  {
    done = true;
    for(int i = 0; i < n-1; i++)
    {
      count++;
      if(a[i] > a[i+1])
      {
        done = false;
        int b = a[i];
        a[i] = a[i+1];
        a[i+1] = b;
      }
    }
  }
}

int compare(const void* x, const void* y)
{
  count++;
  int a = *(int*)x; // ganz streng: int a = *(const int*)x;
  int b = *(int*)y;
  if(a > b)
  {
    return 1;
  }
  else if(a == b)
  {
    return 0;
  }
  return -1;
}

#define MAX_NUMBER_OF_ELEMENTS 100
int a[MAX_NUMBER_OF_ELEMENTS];

int main( void )
{
  for(int n = 5; n < MAX_NUMBER_OF_ELEMENTS; n *= 2)
  {
    const int numberOfRounds = 10;
    long sum = 0;
    long maximum = 0;
    for(int r = 0; r < numberOfRounds; r++)
    {
      for(int i = 0; i < n; i++)
      {
        a[i] = rand();
      }
      
      count = 0;
      //bubblesort(a, n);
      qsort(a, n, sizeof(int), compare);
      sum += count;
      if(count > maximum)
      {
        maximum = count;
      }
    }
    printf("%d %ld %ld\n", n, sum/numberOfRounds, maximum);
  }
  return 0;
}
